require "git"
require "style_pusher/utils/git_driver"

module StylePusher
  def self.push(stylesheet:, 
                git_url:, 
                git_branch_name:, 
                git_commit_message:, 
                stylesheets_location:)
    
    parent_directory = File.expand_path("..", Dir.pwd)
    branch_name = git_branch_name.gsub(" ", "_").downcase
    project_name = project_name(git_url: git_url)
    local_repo = File.join(parent_directory, project_name)
    upload_location = "#{local_repo}/#{stylesheets_location}"

    stylesheets = [
      {
        name: "blah.scss",
        content: stylesheet
      }
    ]

    GitDriver.push(url: git_url, 
                    local_repo: local_repo,
                    branch_name: branch_name,
                    project_name: project_name,
                    stylesheets: stylesheets, #later this should be an array 
                    upload_location: upload_location,
                    commit_message: git_commit_message)
  end
  
  private
  def self.project_name(git_url:)
    @repo_name ||= git_url.split("git@github.com:").last.split(".git").first.split("/").last
  end
end
