require "pry"
class GitDriver
  def self.push(url:, local_repo:, branch_name:, project_name:, stylesheets:, upload_location:, commit_message:)
                    
    #Configure git
    git = create_or_pull(local_path: local_repo, url: url, project_name: project_name)

    #Crete and checkout a branch
    git.branch(branch_name).checkout

    #Commit changes
    upload_stylesheets(stylesheets, upload_location)
    git.add
    git.commit(commit_message)
    
    #Push the branch
    git.push("origin", branch_name, f: true)
    
    #Remove the local branch
    git.checkout("master")
    git.branch(branch_name).delete
  end

  private  
  def self.create_or_pull(local_path:, url:, project_name:) 
    begin
      git = Git.open(local_path)
      git.pull
      return git
    rescue
      parent_dir = File.expand_path("..", local_path)
      return Git.clone(url, project_name, path: parent_dir)
    end
  end
  
  def self.upload_stylesheets(stylesheets, location)
    stylesheets.each do |stylesheet|
      # left off here
      File.write("#{location}/#{stylesheet[:name]}", stylesheet[:content])
    end
  end
end
